<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/postcard-1.0.1/src/varint.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>varint.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../postcard/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
</pre><pre class="rust"><code><span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">varint_max</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Sized</span><span class="op">&gt;</span>() -&gt; <span class="ident">usize</span> {
    <span class="kw">const</span> <span class="ident">BITS_PER_BYTE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">8</span>;
    <span class="kw">const</span> <span class="ident">BITS_PER_VARINT_BYTE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">7</span>;

    <span class="comment">// How many data bits do we need for this type?</span>
    <span class="kw">let</span> <span class="ident">bits</span> <span class="op">=</span> <span class="ident">core::mem::size_of</span>::<span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>() <span class="op">*</span> <span class="ident">BITS_PER_BYTE</span>;

    <span class="comment">// We add (BITS_PER_BYTE - 1), to ensure any integer divisions</span>
    <span class="comment">// with a remainder will always add exactly one full byte, but</span>
    <span class="comment">// an evenly divided number of bits will be the same</span>
    <span class="kw">let</span> <span class="ident">roundup_bits</span> <span class="op">=</span> <span class="ident">bits</span> <span class="op">+</span> (<span class="ident">BITS_PER_BYTE</span> <span class="op">-</span> <span class="number">1</span>);

    <span class="comment">// Apply division, using normal &quot;round down&quot; integer division</span>
    <span class="ident">roundup_bits</span> <span class="op">/</span> <span class="ident">BITS_PER_VARINT_BYTE</span>
}

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">varint_usize</span>(<span class="ident">n</span>: <span class="ident">usize</span>, <span class="ident">out</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>; <span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>()]) -&gt; <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>] {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">n</span>;
    <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>() {
        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">=</span> <span class="ident">value</span>.<span class="ident">to_le_bytes</span>()[<span class="number">0</span>];
        <span class="kw">if</span> <span class="ident">value</span> <span class="op">&lt;</span> <span class="number">128</span> {
            <span class="kw">return</span> <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..<span class="op">=</span><span class="ident">i</span>];
        }

        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">|</span><span class="op">=</span> <span class="number">0x80</span>;
        <span class="ident">value</span> <span class="op">&gt;</span><span class="op">&gt;</span><span class="op">=</span> <span class="number">7</span>;
    }
    <span class="macro">debug_assert_eq!</span>(<span class="ident">value</span>, <span class="number">0</span>);
    <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..]
}

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">varint_u16</span>(<span class="ident">n</span>: <span class="ident">u16</span>, <span class="ident">out</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>; <span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u16</span><span class="op">&gt;</span>()]) -&gt; <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>] {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">n</span>;
    <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u16</span><span class="op">&gt;</span>() {
        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">=</span> <span class="ident">value</span>.<span class="ident">to_le_bytes</span>()[<span class="number">0</span>];
        <span class="kw">if</span> <span class="ident">value</span> <span class="op">&lt;</span> <span class="number">128</span> {
            <span class="kw">return</span> <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..<span class="op">=</span><span class="ident">i</span>];
        }

        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">|</span><span class="op">=</span> <span class="number">0x80</span>;
        <span class="ident">value</span> <span class="op">&gt;</span><span class="op">&gt;</span><span class="op">=</span> <span class="number">7</span>;
    }
    <span class="macro">debug_assert_eq!</span>(<span class="ident">value</span>, <span class="number">0</span>);
    <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..]
}

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">varint_u32</span>(<span class="ident">n</span>: <span class="ident">u32</span>, <span class="ident">out</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>; <span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>()]) -&gt; <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>] {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">n</span>;
    <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>() {
        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">=</span> <span class="ident">value</span>.<span class="ident">to_le_bytes</span>()[<span class="number">0</span>];
        <span class="kw">if</span> <span class="ident">value</span> <span class="op">&lt;</span> <span class="number">128</span> {
            <span class="kw">return</span> <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..<span class="op">=</span><span class="ident">i</span>];
        }

        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">|</span><span class="op">=</span> <span class="number">0x80</span>;
        <span class="ident">value</span> <span class="op">&gt;</span><span class="op">&gt;</span><span class="op">=</span> <span class="number">7</span>;
    }
    <span class="macro">debug_assert_eq!</span>(<span class="ident">value</span>, <span class="number">0</span>);
    <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..]
}

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">varint_u64</span>(<span class="ident">n</span>: <span class="ident">u64</span>, <span class="ident">out</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>; <span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span>()]) -&gt; <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>] {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">n</span>;
    <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span>() {
        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">=</span> <span class="ident">value</span>.<span class="ident">to_le_bytes</span>()[<span class="number">0</span>];
        <span class="kw">if</span> <span class="ident">value</span> <span class="op">&lt;</span> <span class="number">128</span> {
            <span class="kw">return</span> <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..<span class="op">=</span><span class="ident">i</span>];
        }

        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">|</span><span class="op">=</span> <span class="number">0x80</span>;
        <span class="ident">value</span> <span class="op">&gt;</span><span class="op">&gt;</span><span class="op">=</span> <span class="number">7</span>;
    }
    <span class="macro">debug_assert_eq!</span>(<span class="ident">value</span>, <span class="number">0</span>);
    <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..]
}

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">varint_u128</span>(<span class="ident">n</span>: <span class="ident">u128</span>, <span class="ident">out</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>; <span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u128</span><span class="op">&gt;</span>()]) -&gt; <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>] {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">n</span>;
    <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">varint_max</span>::<span class="op">&lt;</span><span class="ident">u128</span><span class="op">&gt;</span>() {
        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">=</span> <span class="ident">value</span>.<span class="ident">to_le_bytes</span>()[<span class="number">0</span>];
        <span class="kw">if</span> <span class="ident">value</span> <span class="op">&lt;</span> <span class="number">128</span> {
            <span class="kw">return</span> <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..<span class="op">=</span><span class="ident">i</span>];
        }

        <span class="ident">out</span>[<span class="ident">i</span>] <span class="op">|</span><span class="op">=</span> <span class="number">0x80</span>;
        <span class="ident">value</span> <span class="op">&gt;</span><span class="op">&gt;</span><span class="op">=</span> <span class="number">7</span>;
    }
    <span class="macro">debug_assert_eq!</span>(<span class="ident">value</span>, <span class="number">0</span>);
    <span class="kw-2">&amp;mut</span> <span class="ident">out</span>[..]
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>